/**
 * Created by michael on 3/11/15.
 */

var scrollSpeed = 'fast';

    // Scrolling
$(window).scroll($.debounce( 250, true, function()
{
    isScrolling = true;
    window.SynchJS.notifyScrollStart();

}));

var lastScrollTop = 0, delta = 5;
var scrollingFromPrependAction = false;

// Finished scrolling
$(window).scroll($.debounce( 250, function()
{

    // if we've finished scrolling because of a prepend action, dont do anything more here
    if( scrollingFromPrependAction )
    {
        scrollingFromPrependAction = false;
        return;
    }

    var scrollDown = false;
    var scrollUp = false;

    // detect scroll direction
    var st = $(this).scrollTop();


    if(Math.abs(lastScrollTop - st) > delta)
    {
        if (st > lastScrollTop)
        {
            scrollDown = true;
        } else
        {
            scrollUp = true;
        }
    }
    else if( st == 0 )
    {
        scrollUp = true;
    }

    lastScrollTop = st;

    // get the current top most visible & readable element
    var visElemIndex = getIndexOfVisibleReadableElement();
    if( visElemIndex >= 0 ) {
        var topMostNode = getNodeForElementIndex(visElemIndex);

        // calculate the offset of that wrt window
        var eTop = $(topMostNode).offset().top;                 //get the offset top of the element
        var topMostNodeOffset = eTop - $(window).scrollTop();  //position of the ele w.r.t window

        // Do something when we get within 10% of the bottom or top and scrolling down/up
        if (scrollDown &&
            (window.innerHeight + window.scrollY) >= document.body.offsetHeight - (0.1 * document.body.offsetHeight)) {
            // you're at the bottom of the page
            var nextFileIndexToLoad = findIndexOfNextFileToAppendToDocument();
            if (nextFileIndexToLoad > 0) {
                appendDocument(nextFileIndexToLoad);
            }
        }
        else if (scrollUp &&
            window.scrollY <= (0.1 * document.body.offsetHeight)) {
            var prevFileIndexToLoad = findIndexOfNextFileToPrependToDocument();
            if (prevFileIndexToLoad >= 0) {
                scrollingFromPrependAction = true;
                prependDocument(prevFileIndexToLoad, visElemIndex, topMostNodeOffset);

            }
        }
    }
    else
    {
        // see if we're at the bottom of the current loaded doc
        if (scrollDown &&
            (window.innerHeight + window.scrollY) >= document.body.offsetHeight)
        {
            var nextFileIndexToLoad = findIndexOfNextFileToAppendToDocument();
            if (nextFileIndexToLoad > 0) {
                appendDocument(nextFileIndexToLoad);
            }

        }
    }

    var wordHighlights = document.getElementsByTagName("vdword");
    if( wordHighlights.length > 0 )
    {
        cursorIsVisible = isElementInViewport(wordHighlights[wordHighlights.length-1]);

        if( cursorIsVisible )
        {
            drawLineHighlight();
        }

        notifyCursorVisibility();
    }


    isScrolling = false;

    if( visElemIndex >= 0)
    {
        window.SynchJS.notifyCurrentElementIndexInWebview(cursorIsVisible, visElemIndex);
    }


    if(initialCursorShowRequested)
    {
        initialCursorShowRequested = false;
        notifyInitialCursorShown();
    }

}));


/**
 *  THis function detects when we've scrolled to the left and corrects
 *  it, but only at the end of the scroll. Not a perfect solution to the
 *  horizontal webview scrolling issue but better than nothing.
 */
$(document).scroll(function()
{
    var doc = document.documentElement;
    var left = (window.pageXOffset || doc.scrollLeft) - (doc.clientLeft || 0);
    var top = (window.pageYOffset || doc.scrollTop)  - (doc.clientTop || 0);

    if( left > 0)
    {
        window.scrollTo(0, top);
    }

})

function notifyCursorVisibility()
{
    window.SynchJS.notifyCursorVisibilityInWebview(cursorIsVisible);
}

function notifyManualScrollComplete()
{
    window.SynchJS.notifyManualScrollComplete();
}

function notifyInitialCursorShown()
{
    window.SynchJS.notifyInitialCursorShown();
}


function scrollInitialCursorIntoView(cursorPagePositionSetting)
{
    initialCursorShowRequested = true;

    if( !isDrawCursorVisible())
    {
        scrollCursorIntoView(cursorPagePositionSetting);
    }
    else
    {
        notifyInitialCursorShown();
    }

}

function scrollToElementLocation(elementIndex)
{
    var vdNode = getNodeForElementIndex(elementIndex);
    if( vdNode == null ) return;

    manualScroll = true;
    if( elementIndex >= totalElementNodes)
    {
        scrollElementToBottom(vdNode);
    }
    else
    {
        scrollElementToTop(vdNode);
    }

}

function scrollToElementLocationForFileIndex(fileIndex, elementIndex)
{
    var highestLoadedIndex = getHighestLoadedFileIndex();
    var lowestLoadedIndex = getLowestLoadedFileIndex();

    console.log("scrollToElementLocationForFileIndex called, index="+fileIndex+" highest loaded file index="+highestLoadedIndex+" lowest loaded="+lowestLoadedIndex);

    if( fileIndex > highestLoadedIndex )
    {
        // load the intervening files
        for( var i = highestLoadedIndex+1; i <= fileIndex; i++)
        {
            appendDocument(i);
        }
    }
    else if( fileIndex < lowestLoadedIndex )
    {
        // load the preceding files
        for( var i = lowestLoadedIndex-1; i >= fileIndex; i--)
        {
            var subDocument = loadFiles[i];
            $.ajax({
                url: subDocument,
                success: function (data)
                {
                    $("body").prepend(data);

                    // Mark the file as loaded
                    setFileLoadFlagLoaded(fileIndex);

                    window.SynchJS.notifyFileLoaded(fileIndex);
                },
                dataType: 'html'
            });

            $("a").removeAttr("href");
        }

        // update the notifiers to cover the newly prepended content
        setupDoubletapNotifier();
        setupLongPressNotifier();
    }

    // Now do the scroll to the required element index (giving
    // a little time for the DOM to update
    setTimeout(function()
    {
        hideSpinner();

        scrollToElementLocation(elementIndex);

    }, 500);
}


var scrollElementToMiddle = function(el)
{
    var wHeight = Math.max(document.documentElement.clientHeight, window.innerHeight || 0);

    var elementBottom = $(el).offset().top + ( $(el).outerHeight(true) / 2);
    var middleScrollPos =  elementBottom - (wHeight / 2);

    $('html,body').animate(
        {
            scrollTop: middleScrollPos
        }, scrollSpeed);
}

var scrollElementToBottom = function(el)
{
    var wHeight = Math.max(document.documentElement.clientHeight, window.innerHeight || 0);

    var elBottom =  $(el).offset().top + $(el).height();
    var bottom = elBottom + (wHeight / 2);

    $('html,body').animate(
        {
            scrollTop: elBottom
        }, scrollSpeed);
}

var scrollElementToTop = function(el)
{
    var adjustment = isFullScreen ? 5 : 4;
    $('html,body').animate(
        {
            scrollTop: $(el).offset().top - adjustment

        }, scrollSpeed);

}

function isDrawCursorVisible()
{
    var wordHighlights = document.getElementsByTagName("vdword");

    if( wordHighlights.length > 0)
    {
        var theWordHighlight = wordHighlights[wordHighlights.length - 1];

        return isElementInViewport(theWordHighlight);
    }

    return false;
}

function scrollCursorIntoView(cursorPagePositionSetting)
{
    var wordHighlightElement = getWordHighlight();

    if( cursorPagePositionSetting == CURSOR_PAGE_POSITION_ON_PAGE )
    {
        if( !isElementInViewport(wordHighlightElement))
        {
            window.SynchJS.notifyManualScrollInProgress();

            scrollElementToTop(wordHighlightElement);
        }
    }
    else if( cursorPagePositionSetting == CURSOR_PAGE_POSITION_CENTERED )
    {
        window.SynchJS.notifyManualScrollInProgress();

        scrollElementToMiddle(wordHighlightElement);
    }
}


function loadInitialSubDocument(fileIndex)
{
    var subDocument = loadFiles[fileIndex];

    console.log("loading file: "+subDocument);


    $.ajax({
        url: subDocument,
        success: function (data)
        {
            $('body').append(data);

            // Mark the file as loaded
            // Mark the file as loaded
            setFileLoadFlagLoaded(fileIndex);


            // Update for location values by determining the current loaded element index
            // and letting the java side know about it when we notify that the initial
            // doc view is ready
            setTimeout(function()
            {
                var visElemIndex = getIndexOfVisibleReadableElement();
                window.SynchJS.notifyDocumentBodyLoaded(visElemIndex);

                // strip out href tags on links to allow the android webview
                // control to detect/handle text selection (long press) properly
                // - without this it ignores long press on links
                $("a").removeAttr("href");

            }, 500);



        },
        dataType: 'html'
    });
}

var firstInitialSubDocLoadIndex;
var lastInitialSubDocLoadIndex;

function loadInitialSubDocuments()
{
    // Determine the indexes of the first three sub docs we
    // want to load (may be less than three but we'll always
    // at least load the primary doc as indicated by the firstLoadFileIndex
    if( firstLoadFileIndex > 0 )
    {
        firstInitialSubDocLoadIndex = firstLoadFileIndex - 1;
    }

    if( firstLoadFileIndex < loadFiles.length - 1)
    {
        lastInitialSubDocLoadIndex = firstLoadFileIndex + 1;
    }

    if( firstInitialSubDocLoadIndex != null )
    {
        loadFirstInitialSubDoc();
    }
    else
    {
        loadPrimaryInitialSubDoc();
    }
}

function loadFirstInitialSubDoc()
{
    var subDocument = loadFiles[firstInitialSubDocLoadIndex];

    console.log("loading file: "+subDocument);


    $.ajax({
        url: subDocument,
        success: function (data)
        {
            $('body').append(data);

            // Mark the file as loaded
            setFileLoadFlagLoaded(firstInitialSubDocLoadIndex);

            // Go ahead and load the primary doc
            loadPrimaryInitialSubDoc();

        },
        dataType: 'html'
    });
}

function loadPrimaryInitialSubDoc()
{
    var subDocument = loadFiles[firstLoadFileIndex];

    console.log("loading file: "+subDocument);

    $.ajax({
        url: subDocument,
        success: function (data)
        {
            $('body').append(data);

            // Mark the file as loaded
            setFileLoadFlagLoaded(firstLoadFileIndex);

            // If there is a succeeding doc go ahead and load that as well
            if( lastInitialSubDocLoadIndex != null )
            {
                loadLastInitialSubDoc();
            }
            else
            {
                notifyInitialSubDocsLoaded();
            }

        },
        dataType: 'html'
    });
}

function loadLastInitialSubDoc()
{
    var subDocument = loadFiles[lastInitialSubDocLoadIndex];

    console.log("loading file: "+subDocument);


    $.ajax({
        url: subDocument,
        success: function (data)
        {
            $('body').append(data);

            // Mark the file as loaded
            setFileLoadFlagLoaded(lastInitialSubDocLoadIndex);

            notifyInitialSubDocsLoaded();

        },
        dataType: 'html'
    });
}


function notifyInitialSubDocsLoaded()
{
    // Update for location values by determining the current loaded element index
    // and letting the java side know about it when we notify that the initial
    // doc view is ready
    setTimeout(function()
    {
        var visElemIndex = getIndexOfVisibleReadableElement();
        window.SynchJS.notifyDocumentBodyLoaded(visElemIndex);

        // strip out href tags on links to allow the android webview
        // control to detect/handle text selection (long press) properly
        // - without this it ignores long press on links
        $("a").removeAttr("href");

    }, 500);
}

/**
 * Indicate whether the initial sub documents to be loaded at first
 * startup of the webview have been loaded into the webview.
 * These 'initial' docs constitute up to three documents - at
 * the initial file load index, prior and after that index (if either
 * or both exist
 */
function allInitialSubDocumentsLoaded()
{


    // Consider the doc ready if all three docs
    // are flagged as loaded
    return  fileLoadFlags[firstSubDocLoadIndex] &&
            fileLoadFlags[firstLoadFileIndex] &&
            fileLoadFlags[lastSubDocLoadIndex];
}


function appendDocument(fileIndex)
{
    var subDocument = loadFiles[fileIndex];

    console.log("appending file at index: "+fileIndex);

    $.ajax({
        url: subDocument,
        success: function (data)
        {
            $('body').append(data);

            // Mark the file as loaded
            setFileLoadFlagLoaded(fileIndex);

            $("a").removeAttr("href");
        },
        dataType: 'html'
    });
}

var prependIndex = 0;

function prependDocument(fileIndex)
{
    var subDocument = loadFiles[fileIndex];

    console.log("prepending file: "+subDocument);

    $.ajax({
        url: subDocument,
        success: function (data)
        {
            var viewTop = $( window ).scrollTop();
            console.log("scrollTop before prepend="+viewTop);

            var divId = "prepend"+prependIndex;
            prependIndex++;
            var divContent = "<div id="+divId + ">" + data + "</div>";
            $('body').prepend(divContent);

            var prependedDataHeight = $("#"+divId).height();

            $( window ).scrollTop( viewTop + prependedDataHeight + 25 );

            setFileLoadFlagLoaded(fileIndex);

        },
        dataType: 'html'
    });
}

function findIndexOfNextFileToAppendToDocument()
{
    var result = -1;

    // First find the highest index of a loaded file. Then see if there
    // are any remaining unloaded files (looking ahead in the array
    var highestLoadedFileIndex = getHighestLoadedFileIndex();

    // Right now get the next index if possible
    if( highestLoadedFileIndex < fileLoadFlags.length - 1)
    {
        // Still remaining file(s) to load so return the index
        // of the next file to load (ie the one after the
        // highest loaded file index)
        result = highestLoadedFileIndex + 1;
    }

    return result;
}

function getHighestLoadedFileIndex()
{
    var highestLoadedFileIndex = 0;
    for( var i = firstLoadFileIndex; i < fileLoadFlags.length; i++)
    {
        if( fileLoadFlags[i] && i > highestLoadedFileIndex)
        {
            highestLoadedFileIndex = i;
        }
    }
    return highestLoadedFileIndex;
}

function findIndexOfNextFileToPrependToDocument()
{
    var result = -1;

    // First find the highest index of a loaded file. Then see if there
    // are any remaining unloaded files (looking ahead in the array
    var lowestLoadedFileIndex = getLowestLoadedFileIndex();

    // Right now get the next index if possible
    if( lowestLoadedFileIndex > 0 && lowestLoadedFileIndex <= firstLoadFileIndex)
    {
        // Still remaining file(s) to load so return the index
        // of the next file to load (ie the one after the
        // highest loaded file index)
        result = lowestLoadedFileIndex - 1;
    }

    return result;
}

function getLowestLoadedFileIndex()
{
    var lowestLoadedFileIndex = fileLoadFlags.length + 1;
    for( var i = firstLoadFileIndex; i >= 0; i--)
    {
        if( fileLoadFlags[i] && i < lowestLoadedFileIndex)
        {
            lowestLoadedFileIndex = i;
        }
    }
    return lowestLoadedFileIndex;
}

function setFileLoadFlagLoaded(fileIndex)
{
    fileLoadFlags[fileIndex] = true;

    setupDoubletapNotifier();
    setupLongPressNotifier();

    $("img").unveil();

    window.SynchJS.notifyFileLoaded(fileIndex);
}

var spinner = null;

function getSpinnerDiv()
{
    var newDiv = $("<div>", {id:SPINNER_DIV_ID, style:"position:fixed;top:60%;left:50%"});
    $( "body" ).append(newDiv);

    spinnerDiv = document.getElementById(SPINNER_DIV_ID);

    return spinnerDiv;
}

function showSpinner()
{
    var spinnerDiv = getSpinnerDiv();
    spinner = new Spinner().spin(spinnerDiv);

}

function hideSpinner()
{
    if( spinner != null )
    {
        var spinnerDiv = getSpinnerDiv();
        spinner.stop(spinnerDiv);
    }
}

var init_spinner = null;
var spinDiv = null;

function getInitSpinnerDiv()
{
    var midHeight = screenHeight / 2;
    var midWidth = screenWidth / 2;

    var newDiv = $("<div>", {id:INIT_SPINNER_DIV_ID}).css("position","absolute").css("top",midHeight).css("left",midWidth);
    $( "body" ).append(newDiv);

    spinDiv = document.getElementById(INIT_SPINNER_DIV_ID);

    return spinDiv;
}


function showInitSpinner()
{
    var spinnerDiv = getInitSpinnerDiv();
    init_spinner = new Spinner().spin(spinnerDiv);

}


function hideInitSpinner()
{
    if( init_spinner != null )
    {
        init_spinner.stop(spinDiv);
    }

    $("#loadingMsg").remove();

}