/**
 * Created by michael on 11/10/14.
 */


/*
 * In the supplied element find the nearest text word at the supplied
 * coordinates
 */
function handleDoubleTapEvent( elem, x, y)
{
    console.log("handleDoubleTapEvent");
    var elemRange = document.caretRangeFromPoint(x, y);

    // find the readable element if any this element is embedded within
    var containingNode = elemRange.startContainer;
    while( containingNode != null )
    {
        if(containingNode.hasAttribute && containingNode.hasAttribute(VD_READABLE_ELEMENT_ATTRIBUTE))
        {
            break;
        }
        else
        {
            containingNode = containingNode.parentNode;
        }
    }

    if( containingNode == null ) return;

    //var nodeIndex = $(VD_cssSelector).index(containingNode);
    var elemIndexStr = containingNode.getAttribute(VD_READABLE_ELEMENT_INDEX_ATTRIBUTE);
    var nodeIndex = parseInt(elemIndexStr);

    var rangyElem = rangy.createRange();
    rangyElem.selectNode(elemRange.startContainer);

    // Get the range of the selected node within its voicedream-readable
    // container node
    var rangeInContainer = rangyElem.toCharacterRange(containingNode);

    // Now expand the range element to cover the whole containing node
    // so we can get all the rendered text
    rangyElem.selectNode(containingNode);
    var rawText = containingNode.textContent;
    var renderedText = rangyElem.text();

    // and notify the app of the double tap location details
    window.SynchJS.notifyDoubleTapSelectionPoint(nodeIndex, rawText, renderedText, rangeInContainer.start + elemRange.startOffset);

}

/*
 * Add a hammer-based double tap notifier to the document body; when notified
 * we let the app know of the element and location of the double tap
 */
function setupDoubletapNotifier()
{
    // remove this feature so the android webview still gets
    // the event notifying of the long press (ie entering
    // context action mode)
    delete Hammer.defaults.cssProps.userSelect;
    var bodyElement = document.getElementsByTagName("body");
    var mc = new Hammer.Manager(bodyElement[0]);
    mc.add( new Hammer.Tap( { event: 'doubletap', taps:2, threshold:5, posThreshold:15 }));
    mc.on("doubletap", function(ev)
    {
        handleDoubleTapEvent(ev.target, ev.center.x, ev.center.y);
    });
}

function setupLongPressNotifier()
{
    var bodyElement = document.getElementsByTagName("body");
    var mc = new Hammer.Manager(bodyElement[0]);
    mc.add(new Hammer.Press({event: 'longpress'}));
    mc.on("longpress", function (ev)
    {
        var touchElement = ev.target;

        if( touchElement.className == VOICE_DREAM_PAGE_HIGHLIGHT_CLASS )
        {
            var markId = touchElement.getAttribute(VOICE_DREAM_MARK_ID_ATTR);
            window.SynchJS.notifyLongPressOnMark(markId);
        }
    });
}


function expandSelectionToMark(markId)
{
    var selector = "[" + VOICE_DREAM_MARK_ID_ATTR + "= '"+markId+"']";
    var elList = document.querySelectorAll(selector);
    var range = document.createRange();

    for(var i = 0; i < elList.length; i++)
    {
        range.selectNode(elList[i]);
    }

    var sel = window.getSelection();
    sel.addRange(range);

    // remove any existing highlight with the given mark id
    $(selector).removeAttr("class");


}

function reinstateMarkHighlightClass(markId, highlightStyle)
{
    var selector = "[" + VOICE_DREAM_MARK_ID_ATTR + "= '"+markId+"']";
    var highlightCssClass = highlightStyle == HIGHLIGHT_STYLE_ON_PAGE ? VOICE_DREAM_PAGE_HIGHLIGHT_CLASS
        : VOICE_DREAM_SIDEBAR_HIGHLIGHT_CLASS;

    $(selector).attr("class",highlightCssClass);

}

function setupImageElementSingleTapNotifier(elem)
{
    var mc = new Hammer.Manager(elem);
    mc.add( new Hammer.Tap( { event: 'singletap', taps:1 }));
    mc.on("singletap", function(ev)
    {
        imageElementSingleTapDetected = true;
        console.log("note icon tapped!");
    });
}

function setupImageElementLongPressNotifier(elem)
{
    var mc = new Hammer.Manager(elem);
    mc.add(new Hammer.Press({event: 'longpress', threshold:10, time:300}));
    mc.on("longpress", function(ev)
    {
        imageElementSingleTapDetected = true;
        console.log("note icon longpressed!");
    });
}